/*********************************************************************
 *
 *      ***  HAPPy Pascal compiler ***
 *          input symbol routine
 *
 *               void insymbol(void)
 *                void real_err(int sig, int subcode)
 *
 *            copyright(c) H.Asano  1992,1993
 *
 *              return item -----
 *                sy   : vfsymbol
 *                op   : vf̉Zq^Cv
 *                id   : W
 *                ch   : Ǎ
 *                lgth : 񓙂̒
 *                val  : l
 *
 *********************************************************************/

#define EXTERN extern

#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <jctype.h>
#include "pascomp.h"
#include "pcpcd.h"

/***** function prototype define ******/

extern void gen1(enum pcdmnc, int) ;
extern void pcerr(int,char*);
extern char *inttoch(long)  ;
extern void term(void) ;
extern void *Malloc(int) ;
static void skipspace(void);
static void nextch(void);
static void identifier(void);
static void innumber(void) ;
static long chtoint(int,char*) ;
static void strings(void) ;
static void colonch(void);
static void lparch(void);
static void rparch(void);
static void periodch(void);
static void ltch(void);
static void gtch(void);
static void skipcomment(void);
static void options(void)  ;
static void specialch(void);
static void illegch(void);


/*****************************/
/****      ʕϐ       ****/
/*****************************/

extern FILE   *passource;  /* pascal \[Xt@C|C^ */

/*****************************/
/****      ϐ       ****/
/*****************************/


/***** pascal \e[u *****/
static struct _reswd {
       char          rw[10] ;           /* \           */
       enum symbol   rsy   ;            /* \symbol   */
       enum operator rop   ;            /* \ꒆ̉Zq */
    }  reswd[]  =     {
/*lngh entno  (for frw table) */
/*  2 *   0 */  {"if"       , ifsy     , noop },
/*    *   1 */  {"do"       , dosy     , noop },
/*    *   2 */  {"of"       , ofsy     , noop },
/*    *   3 */  {"to"       , tosy     , noop },
/*    *   4 */  {"in"       , relop    , inop },
/*    *   5 */  {"or"       , addop    , orop },
/*  3 *   6 */  {"end"      , endsy    , noop },
/*    *   7 */  {"for"      , forsy    , noop },
/*    *   8 */  {"var"      , varsy    , noop },
/*    *   9 */  {"div"      , mulop    , idiv },
/*    *  10 */  {"mod"      , mulop    , imod },
/*    *  11 */  {"set"      , setsy    , noop },
/*    *  12 */  {"and"      , mulop    , andop},
/*    *  13 */  {"not"      , notsy    , noop },
/*    *  14 */  {"nil"      , nilsy    , noop },
/*  4 *  15 */  {"then"     , thensy   , noop },
/*    *  16 */  {"else"     , elsesy   , noop },
/*    *  17 */  {"with"     , withsy   , noop },
/*    *  18 */  {"goto"     , gotosy   , noop },
/*    *  19 */  {"case"     , casesy   , noop },
/*    *  20 */  {"type"     , typesy   , noop },
/*    *  21 */  {"file"     , filesy   , noop },
/*  5 *  22 */  {"begin"    , beginsy  , noop },
/*    *  23 */  {"until"    , untilsy  , noop },
/*    *  24 */  {"while"    , whilesy  , noop },
/*    *  25 */  {"array"    , arraysy  , noop },
/*    *  26 */  {"const"    , constsy  , noop },
/*    *  27 */  {"label"    , labelsy  , noop },
/*  6 *  28 */  {"repeat"   , repeatsy , noop },
/*    *  29 */  {"record"   , recordsy , noop },
/*    *  30 */  {"downto"   , downtosy , noop },
/*    *  31 */  {"packed"   , packedsy , noop },
/*  7 *  32 */  {"program"  , progsy   , noop },
/*  8 *  33 */  {"function" , funcsy   , noop },
/*  9 *  34 */  {"procedure", procsy   , noop }
} ;

static int frw[] = {0,0,6,15,22,28,32,33,34,35,35};
    /*  \̒Ť\e[ũT[`Ă */

/***** ǍݑΏJISR[h256ނ𕪗ނ邽߂̃e[u *****/

enum  chtp {
      letter,     /* p             */
      number,     /*              */
      special,    /* ꕶ         */
      illegal,    /* ȂR[h */
      chstrquo,   /* R[e[V   */
      chcolon,    /* :  R        */
      chperiod,   /* . sIh       */
      chlt,       /* <  less than     */
      chgt,       /* >  grater than   */
      chlparen,   /* (        */
      chrparen,   /* )  E      */
      chcoment,   /* {  ߊJn      */
      chspace     /*              */
} ;
static struct  {
       enum chtp     chartp    ;      /* ̃^Cv  */
       enum symbol   ssy       ;      /* symbol  */
       enum operator sop       ;      /* ̉Zq*/
    }  chartb[256]  =    {

 /****** 00-1F : R[h  HT(09),LF(0A)space  ȊOillegal *******/
 /*00-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*03-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*06-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*09-*/{chspace,othersy,noop}, {chspace,othersy,noop}, {illegal,othersy,noop},
 /*0C-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*0F-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*12-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*15-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*18-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*1B-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*1E-*/{illegal,othersy,noop}, {illegal,othersy,noop},

   /****** 20-2F : e핶 ******/
 /* sp  (20) */    {chspace,othersy,noop},
 /* !   (21) */    {illegal,othersy,noop},
 /* "   (22) */    {illegal,othersy,noop},
 /* #   (23) */    {illegal,othersy,noop},
 /* $   (24) */    {special,othersy,noop},
 /* %   (25) */    {illegal,othersy,noop},
 /* &   (26) */    {illegal,othersy,noop},
 /* '   (27) */    {chstrquo,othersy,noop},
 /* (   (28) */    {chlparen,lparent,noop},
 /* )   (29) */    {chrparen,rparent,noop},
 /* *   (2A) */    {special,mulop,mul},
 /* +   (2B) */    {special,addop,plus},
 /* ,   (2C) */    {special,comma,noop},
 /* -   (2D) */    {special,addop,minus},
 /* .   (2E) */    {chperiod,period,noop},
 /* /   (2F) */    {special,mulop,rdiv},

   /****** 30-39:  ******/
 /*012*/ {number,othersy,noop}, {number,othersy,noop}, {number,othersy,noop},
 /*345*/ {number,othersy,noop}, {number,othersy,noop}, {number,othersy,noop},
 /*678*/ {number,othersy,noop}, {number,othersy,noop}, {number,othersy,noop},
 /*9  */ {number,othersy,noop},

   /****** 3A-40 : e핶 ******/
 /* :   (3A) */    {chcolon,colon,noop},
 /* ;   (3B) */    {special,semicolon,noop},
 /* <   (3C) */    {chlt,relop,ltop},
 /* =   (3D) */    {special,relop,eqop},
 /* >   (3E) */    {chgt,relop,gtop},
 /* ?   (3F) */    {illegal,othersy,noop},
 /* @   (40) */    {special,arrow,noop},  /* ^  p */

   /****** 41-5A : p啶 ******/
 /*ABC*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*DEF*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*GHI*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*JKL*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*MNO*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*PQR*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*STU*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*VWX*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*YZ */ {letter,othersy,noop}, {letter,othersy,noop},

   /****** 5B-60 : e핶 ******/
 /* [   (5B) */    {special,lbrack,noop},
 /* \   (5C) */    {illegal,othersy,noop},
 /* ]   (5D) */    {special,rbrack,noop},
 /* ^   (5E) */    {special,arrow,noop},
 /* _   (5F) */    {illegal,othersy,noop},
 /* `   (60) */    {illegal,othersy,noop},

  /****** 61-7A : p ******/
 /*abc*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*def*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*ghi*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*jkl*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*mno*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*pqr*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*stu*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*vwx*/ {letter,othersy,noop}, {letter,othersy,noop}, {letter,othersy,noop},
 /*yz */ {letter,othersy,noop}, {letter,othersy,noop},

   /****** 7B-7F : e핶 ******/
 /* {   (7B) */    {chcoment,othersy,noop},
 /* |   (7C) */    {illegal, othersy,noop},
 /* }   (7D) */    {illegal, othersy,noop},
 /*(7E-7F)*/       {illegal, othersy,noop}, {illegal,othersy,noop},

   /***** 80-FF : eL & J^Ji ******/
 /*80-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*83-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*86-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*89-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*8C-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*8F-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*92-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*95-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*98-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*9B-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*9E-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*A1-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*A4-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*A7-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*AA-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*AD-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*B0-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*B3-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*B6-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*B9-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*BC-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*BF-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*C2-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*C5-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*C8-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*CB-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*CE-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*D1-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*D4-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*D7-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*DA-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*DD-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*E0-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*E3-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*E6-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*E9-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*EC-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*EF-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*F2-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*F5-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*F8-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*FB-*/{illegal,othersy,noop}, {illegal,othersy,noop}, {illegal,othersy,noop},
 /*FE-*/{illegal,othersy,noop}, {illegal,othersy,noop}
 };

static boolean eolnflag    = true  ;    /* EOLNo true            */
static boolean period2flag = false ;    /*  ".." o true*/
static boolean rbrackflag  = false ;    /*  ".)" o true*/

/*************************************************************************/

/**************************************/
/*   insymbol() : symbol̓ǍC  */
/**************************************/

void insymbol(void)
{
     skipspace() ;                      /* 󔒓ǂݔ΂             */
     switch(chartb[ch].chartp) {
       case letter  : identifier()  ;  break; /* O           */
       case number  : innumber()    ;  break; /*            */
       case chstrquo: strings()     ;  break; /*            */
       case chcolon : colonch()     ;  break; /* :              */
       case chperiod: periodch()    ;  break; /* .              */
       case chlt    : ltch()        ;  break; /* <              */
       case chgt    : gtch()        ;  break; /* >              */
       case chlparen: lparch()      ;  break; /* (              */
       case chrparen: rparch()      ;  break; /* )              */
       case chcoment: skipcomment() ;  break; /* ߂           */
       case special : specialch()   ;  break; /* ꕶ         */
       case illegal : illegch()     ;  break; /* s         */
    /* case chspace :                   ---> case͂蓾Ȃ */
     };
}

/**************************************/
/*  skipspace() : 󔒓ǂݔ΂      */
/**************************************/
static void skipspace(void)
{
     while(chartb[ch].chartp == chspace)
      nextch();
}

/**************************************/
/*    nextch() : 1Ǎ      */
/**************************************/
static void nextch(void)
{
  static boolean eofflag  = false ;     /* EOFo  true            */
  int lch ;

     if(eofflag) {
      pcerr(610,"") ;                   /* EOFo                    */
      term() ;                          /* I                   */
     }

     if(eolnflag) {                    /* O̕s̏I肾*/
      lineno++;
      do ;
       while((lch=getc(passource)) == ' '); /* 󔒓ǂݔ΂         */
     }

     if(!eolnflag) lch = getc(passource) ;

     eofflag  = feof(passource) ;
     eolnflag = (lch == '\n') ;
     ch = (eofflag)                     /* EOF̎  Ǎ  */
           ? ' ' : lch ;

}

/**************************************/
/*     identifier() : Ȍ      */
/**************************************/
static void identifier(void)
{
  int k=0;
  int i;
  enum chtp wktype ;

     for(i=0;i<=MaxIDlng;i++)          /* null NA                */
      id[i]='\0';
                             /***** ̂߂Ƀ|C^g  *****/
     do {
      if(k<MaxIDlng)                    /* ő厯ʒ܂Ŋi[         */
       *(id+k++)=(('A'<=ch) && (ch<='Z'))  ? (char)ch+' ' : (char)ch ;
                                        /* 啶ɕϊ       */
      nextch();
      } while(((wktype=(*(chartb+ch)).chartp) == letter) ||
	      ( wktype                        == number)) ;

      for(i=*(frw+k-1); i<*(frw+k);i++) { /* \e[uT[`     */
       if(!strcmp(id,(*(reswd+i)).rw)) {  /* \ł鎞           */
	sy = (*(reswd+i)).rsy ;           /* ΉsymbolԂ     */
        op = (*(reswd+i)).rop ;
        return;
       }
      }
      sy = ident;                       /* \ȊO̎́Aident    */
      op = noop;
}

/**************************************/
/*     innumber() : ̏        */
/**************************************/
static void innumber(void)
{
  char digit[Maxdiglng+1];
  char expdigit[Maxdiglng+1];
  csp *lvp ;
  int i=0 ;
  int k   ;
  int w   ;
  float realvalue ;
  char *stopstring ;

     op = noop ;

     for(w=0;w<=Maxdiglng;w++)          /* null NA                */
      digit[w]='\0';

     do {
      if(i < Maxdiglng) digit[i] = (char)ch ;/* ő吔ȉ̎i[*/
      i++ ;
      nextch() ;
     } while(chartb[ch].chartp == number) ;

     if((ch != '.') && (ch != 'e') && (ch != 'E')){ /* real^łȂ */
      val.ival =chtoint(i,digit) ;      /*  lɕϊ              */
      return ;
     }

     k=i ;
     if(ch == '.') {                    /* _̎                 */
      val.ival = chtoint(i,digit);      /* lɕϊ(l`FbN)   */
      if(k < Maxdiglng) digit[k]=(char)ch;/* ő吔ȉ̎i[   */
      k++ ;
      nextch() ;
      period2flag = (ch == '.') ;       /* ".."                       */
      rbrackflag  = (ch == ')') ;       /* ".)"  ] ̑֕\         */
      if(period2flag || rbrackflag) {   /* ".." ܂ ".)" ̎      */
       return ;
      }
      if(chartb[ch].chartp != number)   /* .̎̕ȊO      */
       pcerr(201,"") ;                  /* ̕\LɌ肪     */
      else {
       do {
        if(k < Maxdiglng) digit[k] = (char)ch ;
        k++ ;
        nextch() ;
       } while(chartb[ch].chartp == number) ;
      }
     }

     if((ch == 'e') || (ch == 'E')) {   /* e̎                      */
      if(k < Maxdiglng) digit[k]=(char)ch;/* ő吔ȉ̎i[   */
      k++ ;
      nextch() ;
      if((ch=='+') || (ch=='-')) {      /* e ̎+ - ̎           */
       if(k < Maxdiglng) digit[k]=(char)ch;/* ő吔ȉ̎i[  */
       k++ ;
       nextch() ;
      }
      if(chartb[ch].chartp != number)
       pcerr(201,"") ;                  /* ̕\LɌ           */
      else {
       i = 0;
       do {
        if(k < Maxdiglng) digit[k]    = (char)ch ;
        if(i < Maxdiglng) expdigit[i] = (char)ch ;
        k++ ;
        i++ ;
        nextch() ;
       } while(chartb[ch].chartp == number) ;
       chtoint(i,expdigit) ;            /* w̑傫`FbN     */
      }
     }

     if(k > Maxdiglng) {
      pcerr(207,inttoch((long)Maxdiglng));/*  ͈̌͂zĂ*/
      strcpy(digit,"0.0");              /*  0.0 Ƃ                */
     }

     sy = realconst ;
     lvp = (csp*)Malloc(sizeof(csp)) ;
     lvp->cclass = real ;
     val.valp = lvp ;                   /* ^̒萔AhXݒ */
     lvp->c.rval = (char*)Malloc(k+1);
     *(lvp->c.rval) = ' ' ;             /* 擪͕GA           */
     strcpy(lvp->c.rval+1,digit) ;      /* ]                       */
     realvalue = (float)strtod(lvp->c.rval, &stopstring) ;
      /* ϊG[N邩 G[ƂȂsignalœo^
         G[֐ɔł     */
}

/*****************************************/
/* real_err() : ϊG[̎̏ */
/*  initsignal֐œo^       */
/*****************************************/
void real_err(int sig, int subcode)
{
     pcerr(208,"") ;
     signal(SIGFPE,real_err) ;          /* ēo^                     */
}

/*****************************************/
/* chtoint() : 琮ւ̕ϊ  */
/*****************************************/
static long chtoint(int i,char *digit)
{
  long value ;
  int j ;

     sy = intconst ;
     value = 0  ;
     for(j=0;j<i;j++) {                 /* 𐮐ɕϊ           */
      if(value <= (Maxint - (digit[j]-'0')) / 10  ) /* `FbN   */
       value = value*10 + (digit[j]-'0') ;
      else {
       pcerr(203,inttoch(Maxint)) ;     /* Ȃmaxint傫*/
       return(0)        ;
      }
     }
     return(value) ;
}

/**************************************/
/*     strings() : ̏       */
/**************************************/
static void strings(void)
{
  char string[Maxstrlng+1] ;
  char *heapstring ;

     lgth = 0 ;
     sy   = stringconst ;
     op   = noop ;

     do {
      do {
       nextch() ;
       if(lgth<Maxstrlng) string[lgth]=(char)ch;/* ő啶񒷈ȉ̎i[ */
       lgth++ ;
      } while((!eolnflag) && (ch != '\'')) ;
      if(eolnflag) pcerr(202,"") ;      /* 萔͍szĂ͂ȂȂ */
      else nextch() ;                   /* '̎̕ǂ             */
     } while(ch == '\'') ;              /* '2Ƃ͂xJԂ   */

     lgth-- ;                           /* Ō'菜                */
     if(lgth==0) pcerr(205,"") ;        /* 0͋̕Ȃ      */
     else if(lgth == 1)
      val.ival = (long)string[0];       /* 1̎́A̒lvalɓ */
     else {                             /* 2ȏ̎                    */
      val.valp = (csp*)Malloc(sizeof(csp)) ;
      val.valp->cclass = strg ;
      if(lgth > Maxstrlng) {            /* ő啶񒷂zĂ鎞       */
       pcerr(602,inttoch((long)Maxstrlng)) ; /* ̍ő咷zĂ  */
       lgth = Maxstrlng ;               /* ő啶񒷂܂łLƂ     */
      }
      string[lgth] = '\0' ;             /* nullŏI镶Ƃ         */
      heapstring = (char*)Malloc(lgth+1) ;/* 񒷕̃GAm       */
      strcpy(heapstring,string) ;
      val.valp->c.sval = heapstring ;
     }
}

/**************************************/
/*     colonch() : :() ̏      */
/**************************************/
static void colonch(void)
{
     op = noop;
     nextch();
     if(ch == '=') {                    /* ':='                       */
      sy = becomes;                     /*   becomes            */
      nextch();
     }
     else sy = colon ;                  /* ':'  colon           */
}

/**************************************/
/*     lparch() : ( ̏            */
/**************************************/
static void lparch(void)
{
     op = noop   ;
     nextch();
     if(ch == '*') skipcomment();       /* '(*'                   */
     else if(ch == '.') {               /* '(.'   [ ̑֕\        */
      nextch()    ;
      sy = lbrack ;
     }
     else  sy = lparent;
}

/**************************************/
/*     rparch() : ) ̏            */
/**************************************/
static void rparch(void)
{
     op = noop;
     nextch();
     if(rbrackflag) {                   /*  ".)"*/
      sy = rbrack  ;                    /*  ..  */
      rbrackflag = false ;
     }
     else sy = rparent;
}

/*******************************************/
/* skipcomment() : Rg̓ǂݔ΂*/
/*    *) ܂ } Rg̏I       */
/*         } ́AVtgJIS2oCg*/
/*          ɂȂ蓾̂ŁȀ */
/*******************************************/
static void skipcomment(void)
{
     nextch();
     if(ch=='$') {
      options();                        /* $̌ɂ͵߼      */
      if(iskanji(ch)) {
       nextch() ;
       nextch() ;
      }
     }
     if(iskanji(ch)) {
      nextch() ;
      nextch() ;
     }
     do {
      while((ch != '*') && (ch != '}')) {
       if(iskanji(ch)) {
        nextch() ;
        nextch() ;
       }
       else nextch() ;
      }
      if(ch == '}') break   ;           /* }  ȂRgI      */
      else {
       if(iskanji(ch)) {
        nextch() ;
        nextch() ;
       }
       else nextch() ;
      }
     } while(ch != ')') ;
     nextch();
     insymbol();                        /* Lsymbol(ċA)*/
}

/*****************************************/
/* options() : IvVݒ菈        */
/*             d+ d- t+ t-               */
/*****************************************/
static void options(void)
{
  char optionchar ;

     nextch() ;
     optionchar = (char)ch ;
     if((ch=='d') || (ch=='t')) nextch();
     else return ;
     if((ch=='+') || (ch=='-'))
      if(optionchar=='d') debug = (ch=='+') ;
      else
       if(ch=='+') gen1(iTRA,1) ;       /* g[XI  tra  1       */
       else        gen1(iTRA,2) ;       /* g[XIt  tra  2       */
}

/****************************************/
/* periodch() :  .(ص)̏        */
/****************************************/
static void periodch(void)
{
     op = noop;
     nextch();
     if(period2flag) {
      sy = period2 ;                    /*  ..  */
      period2flag = false ;
     }
     else if(ch == '.') {               /*  ..              */
       sy = period2 ;                   /* ..                   */
       nextch();
     }
     else if(ch == ')') {               /*  .)              */
      sy = rbrack ;                     /*  ]   Ƃ                */
      nextch()    ;
     }
     else sy = period ;                 /* . PƂ̎ . Ƃ      */
}

/****************************************/
/*        ltch() :  < ̏            */
/****************************************/
static void ltch(void)
{
     nextch();
     sy=relop;
     if(ch == '=') {                    /* '<='                       */
      op = leop;                        /*       less equal     */
      nextch();
     }
     else if(ch == '>') {               /* '<>'                       */
      op = neop ;                       /*       not equal      */
      nextch()  ;
     }
     else op = ltop ;                   /* '<'   less than Ƃ     */
}

/****************************************/
/*        gtch() :  > ̏            */
/****************************************/
static void gtch(void)
{
     nextch();
     sy = relop;
     if(ch == '=') {                    /* '>='                       */
      op = geop;                        /*   grater equal       */
      nextch();
     }
     else op = gtop ;                   /* '>'  grater than Ƃ    */
}

/****************************************/
/*      specialtch() : ꕶ̏   */
/****************************************/
static void specialch(void)
{
     sy = chartb[ch].ssy ;              /* ̕symbol           */
     op = chartb[ch].sop ;              /* ̉̕Zq           */
     nextch()            ;
}

/****************************************/
/*        illegch() : s̏    */
/****************************************/
static void illegch(void)
{
  char wch[3] ;

     sy = othersy;
     op = noop   ;
     wch[0] = (char)ch ;
     if(iskanji(ch)) {                  /* ̎ ߍݏ  */
      nextch() ;
      wch[1] = (char)ch   ;
      wch[2] = '\0' ;
     }
     else wch[1] = '\0' ;
     pcerr(30,wch)      ;               /* sꂽ           */
     nextch()           ;
}
